#pragma warning( disable : 4996 )

#include <windows.h>
#include <tchar.h>
#include <process.h>
#include <stdio.h>
#include "AviReader.h"
#include "MainDlg.h"
#include "Resource.h"
#include "TMKERNEL.h"
#include "AFFIXWIZARD.h"

#define LARGE_INTEGER_TO_UINT_64(X) ((unsigned __int64)(X).LowPart + ((unsigned __int64)(X).HighPart << 32))

namespace {
C_MainDlg MainDlg;
static const int LANE_WIDTH = 64;
static const int LANE_HEIGHT = 192;
static const int FRAME_WIDTH = 352;
static const int FRAME_HEIGHT = 288;

#pragma pack(push)
#pragma pack(1)
struct S_GrayBitmap {
	BITMAPFILEHEADER BFH;
	BITMAPINFOHEADER BIH;
	RGBQUAD Palette[256];
	BYTE pbData[1];
};
#pragma pack(pop)

struct S_OverlayData {
	int pnDelay[TMKER_MAX_LANES];
	TCHAR szVelocLabel[TMKER_MAX_LANES][8];
	int pnDetected[TMKER_MAX_LANES];
	int nX[TMKER_MAX_LANES];
	int nY[TMKER_MAX_LANES];
};

HMETAFILE BuildMetaFile(TMKER_DESC TMKD, S_TMKER_Affixment *pAffix) {
	int i, j, nSum;
	POINT pptLanes[TMKER_MAX_LANES][4];
	POINT pptArrays[TMKER_MAX_LANES][7];
	POINT ptUpArray[7];
	POINT ptDownArray[7];
	S_TMKER_Point ptSrc, ptDst;
	double dblLanesWidth[TMKER_MAX_LANES];
	double dblArrX;

	if(!TMKD || !pAffix || !pAffix->nLanes)
		return NULL;

	nSum = 0;
	for(i=0; i<pAffix->nLanes; i++)
		nSum += pAffix->nLanesWidth[i];
	if(100 != nSum) {
		if(pAffix->nLanes == 3) {
			dblLanesWidth[0] = LANE_WIDTH * pAffix->nLanes * 33 / 100.0;
			dblLanesWidth[1] = LANE_WIDTH * pAffix->nLanes * 33 / 100.0;
			dblLanesWidth[2] = LANE_WIDTH * pAffix->nLanes * 34 / 100.0;
		}
		else if(pAffix->nLanes == 6) {
			dblLanesWidth[0] = LANE_WIDTH * pAffix->nLanes * 17 / 100.0;
			dblLanesWidth[1] = LANE_WIDTH * pAffix->nLanes * 16 / 100.0;
			dblLanesWidth[2] = LANE_WIDTH * pAffix->nLanes * 17 / 100.0;
			dblLanesWidth[3] = LANE_WIDTH * pAffix->nLanes * 16 / 100.0;
			dblLanesWidth[4] = LANE_WIDTH * pAffix->nLanes * 17 / 100.0;
			dblLanesWidth[5] = LANE_WIDTH * pAffix->nLanes * 17 / 100.0;
		}
		else
			for(i=0; i<pAffix->nLanes; i++)
				dblLanesWidth[i] = LANE_WIDTH;
	}
	else
		for(i=0; i<pAffix->nLanes; i++)
			dblLanesWidth[i] = LANE_WIDTH * pAffix->nLanes * pAffix->nLanesWidth[i] / 100.0;

	ptUpArray[0].y = static_cast<LONG>((LANE_HEIGHT * 1.0) / 11.0);
	ptUpArray[1].y = static_cast<LONG>((LANE_HEIGHT * 2.0) / 11.0);
	ptUpArray[2].y = static_cast<LONG>((LANE_HEIGHT * 2.0) / 11.0);
	ptUpArray[3].y = static_cast<LONG>((LANE_HEIGHT * 3.0) / 11.0);
	ptUpArray[4].y = static_cast<LONG>((LANE_HEIGHT * 2.0) / 11.0);
	ptUpArray[5].y = static_cast<LONG>((LANE_HEIGHT * 2.0) / 11.0);
	ptUpArray[6].y = static_cast<LONG>((LANE_HEIGHT * 1.0) / 11.0);

	ptDownArray[0].y = static_cast<LONG>((LANE_HEIGHT * 1.0) / 11.0);
	ptDownArray[1].y = static_cast<LONG>((LANE_HEIGHT * 2.0) / 11.0);
	ptDownArray[2].y = static_cast<LONG>((LANE_HEIGHT * 2.0) / 11.0);
	ptDownArray[3].y = static_cast<LONG>((LANE_HEIGHT * 3.0) / 11.0);
	ptDownArray[4].y = static_cast<LONG>((LANE_HEIGHT * 3.0) / 11.0);
	ptDownArray[5].y = static_cast<LONG>((LANE_HEIGHT * 2.0) / 11.0);
	ptDownArray[6].y = static_cast<LONG>((LANE_HEIGHT * 2.0) / 11.0);

	dblArrX = 0.0;
	for(i=0; i<pAffix->nLanes; i++) {
		ptSrc.shX = static_cast<short>(dblArrX + 0.5);
		ptSrc.shY = 0;
		TMKER_PrjToScreen(TMKD, &ptSrc, &ptDst);
		pptLanes[i][0].x = ptDst.shX;
		pptLanes[i][0].y = ptDst.shY;

		ptSrc.shX = static_cast<short>(dblArrX + 0.5);
		ptSrc.shY = LANE_HEIGHT;
		TMKER_PrjToScreen(TMKD, &ptSrc, &ptDst);
		pptLanes[i][1].x = ptDst.shX;
		pptLanes[i][1].y = ptDst.shY;

		ptSrc.shX = static_cast<short>(dblArrX + dblLanesWidth[i] + 0.5);
		ptSrc.shY = LANE_HEIGHT;
		TMKER_PrjToScreen(TMKD, &ptSrc, &ptDst);
		pptLanes[i][2].x = ptDst.shX;
		pptLanes[i][2].y = ptDst.shY;

		ptSrc.shX = static_cast<short>(dblArrX + dblLanesWidth[i] + 0.5);
		ptSrc.shY = 0;
		TMKER_PrjToScreen(TMKD, &ptSrc, &ptDst);
		pptLanes[i][3].x = ptDst.shX;
		pptLanes[i][3].y = ptDst.shY;

		ptUpArray[0].x = static_cast<LONG>((dblLanesWidth[i] * 5.0) / 11.0);
		ptUpArray[1].x = static_cast<LONG>((dblLanesWidth[i] * 5.0) / 11.0);
		ptUpArray[2].x = static_cast<LONG>((dblLanesWidth[i] * 4.0) / 11.0);
		ptUpArray[3].x = static_cast<LONG>((dblLanesWidth[i] * 5.5) / 11.0);
		ptUpArray[4].x = static_cast<LONG>((dblLanesWidth[i] * 7) / 11.0);
		ptUpArray[5].x = static_cast<LONG>((dblLanesWidth[i] * 6) / 11.0);
		ptUpArray[6].x = static_cast<LONG>((dblLanesWidth[i] * 6) / 11.0);

		ptDownArray[0].x = static_cast<LONG>((dblLanesWidth[i] * 5.5) / 11.0);
		ptDownArray[1].x = static_cast<LONG>((dblLanesWidth[i] * 4.0) / 11.0);
		ptDownArray[2].x = static_cast<LONG>((dblLanesWidth[i] * 5.0) / 11.0);
		ptDownArray[3].x = static_cast<LONG>((dblLanesWidth[i] * 5.0) / 11.0);
		ptDownArray[4].x = static_cast<LONG>((dblLanesWidth[i] * 6) / 11.0);
		ptDownArray[5].x = static_cast<LONG>((dblLanesWidth[i] * 6) / 11.0);
		ptDownArray[6].x = static_cast<LONG>((dblLanesWidth[i] * 7) / 11.0);

		for(j=0; j<7; j++) {
			if(pAffix->nDirection[i]) {
				ptSrc.shX = static_cast<short>(ptDownArray[j].x + dblArrX + 0.5);
				ptSrc.shY = static_cast<short>(LANE_HEIGHT - 1 - ptDownArray[j].y);
			}
			else {
				ptSrc.shX = static_cast<short>(ptUpArray[j].x +  dblArrX + 0.5);
				ptSrc.shY = static_cast<short>(LANE_HEIGHT - 1 - ptUpArray[j].y);
			}
			TMKER_PrjToScreen(TMKD, &ptSrc, &ptDst);
			pptArrays[i][j].x = ptDst.shX;
			pptArrays[i][j].y = ptDst.shY;
		}
		dblArrX += dblLanesWidth[i];
	}
	HDC m_hDCMetafile = CreateMetaFile(NULL);
	HPEN hPen = static_cast<HPEN>(GetStockObject(WHITE_PEN));
	HBRUSH hBrush = static_cast<HBRUSH>(GetStockObject(NULL_BRUSH));

	SelectObject(m_hDCMetafile, hPen);
	SelectObject(m_hDCMetafile, hBrush);
	for(i=0; i<pAffix->nLanes; i++) {
		MoveToEx(m_hDCMetafile, pptLanes[i][0].x, pptLanes[i][0].y, NULL);
		LineTo (m_hDCMetafile, pptLanes[i][1].x, pptLanes[i][1].y);
		LineTo (m_hDCMetafile, pptLanes[i][2].x, pptLanes[i][2].y);
		LineTo (m_hDCMetafile, pptLanes[i][3].x, pptLanes[i][3].y);
		LineTo (m_hDCMetafile, pptLanes[i][0].x, pptLanes[i][0].y);
		Polygon(m_hDCMetafile, pptArrays[i], 7);
	}
	return CloseMetaFile(m_hDCMetafile);
}

BOOL GetFileName(TCHAR *szFileName, TCHAR *szFilter, BOOL fSave) {
	if(!szFileName)
		return FALSE;

	OPENFILENAME ofn;

	ZeroMemory(&ofn, sizeof(OPENFILENAME));
	ZeroMemory(szFileName, sizeof(szFileName));
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = MainDlg.m_hDlg;
	ofn.hInstance = GetModuleHandle(NULL);
	ofn.lpstrFilter = szFilter;
	ofn.lpstrFile = szFileName;
	ofn.nMaxFile = _MAX_PATH;
	ofn.nMaxFileTitle = _MAX_FNAME + _MAX_EXT;
	if(!fSave) {
		ofn.Flags = OFN_FILEMUSTEXIST;
		return GetOpenFileName(&ofn);
	}
	else
		return GetSaveFileName(&ofn);
}

void Overlay(HDC hDC, HMETAFILE hMF, S_TMKER_Event *pEvent, int nLanes, S_OverlayData *pOD) {
	int i;
	HPEN hWPen, hBPen;
	HBRUSH hBrush;

	hWPen = static_cast<HPEN>(GetStockObject(WHITE_PEN));
	hBPen = static_cast<HPEN>(GetStockObject(BLACK_PEN));
	hBrush = static_cast<HBRUSH>(GetStockObject(WHITE_BRUSH/*NULL_BRUSH*/));
	SelectObject(hDC, hBPen);
	SelectObject(hDC, hBrush);
	if(hMF)
		PlayMetaFile(hDC, hMF);
	for(i=0; i<nLanes; i++) {
		if(pEvent->Events[i].nVehicleSpeed != 0) {
			pOD->pnDelay[i] = 20;
			pOD->nX[i] = pEvent->Events[i].nVehicleOnScreenX;
			pOD->nY[i] = pEvent->Events[i].nVehicleOnScreenY;
			switch(pEvent->Events[i].nVehicleClass) {
			case TMKER_VC_MOTORCYCLE:
				lstrcpy(pOD->szVelocLabel[i], _T("M"));
				break;
			case TMKER_VC_CAR:
				lstrcpy(pOD->szVelocLabel[i], _T("C"));
				break;
			case TMKER_VC_STRUCK:
				lstrcpy(pOD->szVelocLabel[i], _T("S"));
				break;
			case TMKER_VC_MTRUCK:
				lstrcpy(pOD->szVelocLabel[i], _T("T"));
				break;
			case TMKER_VC_BUS:
				lstrcpy(pOD->szVelocLabel[i], _T("B"));
				break;
			case TMKER_VC_LTRUCK:
				lstrcpy(pOD->szVelocLabel[i], _T("L"));
				break;
			}
			_stprintf(&pOD->szVelocLabel[i][1], _T("%d"), pEvent->Events[i].nVehicleSpeed);
		}
		if(pOD->pnDelay[i]) {
			pOD->pnDelay[i]--;
			TextOut(hDC, pOD->nX[i], pOD->nY[i], pOD->szVelocLabel[i], lstrlen(pOD->szVelocLabel[i]));
		}
	}
}

UINT WINAPI ThreadProc(LPVOID lpVoid) {
	C_AviReader Avi;
	TCHAR szAviFileName[MAX_PATH] = _T("");
	TCHAR szAffixFileName[MAX_PATH] = _T("");
	TCHAR szCurDir[MAX_PATH] = _T("");
	S_GrayBitmap *pGBMP = NULL;
	S_AW_CamInternalParams CIParams = {0};
	HWND hWnd = NULL;
	HDC hDC = NULL;
	HDC hMemDC = NULL;
	HBITMAP hBitmap = NULL;
	RECT rcWnd = {0};
	TMKER_DESC Kernel = NULL;
	S_TMKER_Init TMKInit = {0};
	S_TMKER_Event Event = {0};
	S_OverlayData OD = {0};
	HMETAFILE hMF = NULL;
	int i, nDelay;
	TMKER_RESULT TMKRes;

	LARGE_INTEGER CPUTicks;
	unsigned __int64 n64Tmp;
	unsigned __int64 n64Acc = 0;
	unsigned __int64 n64FrmCnt = 0;

	try {
		GetCurrentDirectory(MAX_PATH - 1, szCurDir);

			// Get AVI file name.
		if(!GetFileName(szAviFileName, _T("AVI Files (*.avi)\0*.avi\0\0"), FALSE))	
			return 0;
		if(!Avi.Open(szAviFileName))
			return 0;

		pGBMP = (S_GrayBitmap*)GlobalAlloc(GPTR, sizeof(S_GrayBitmap) + Avi.Width() * Avi.Height() - 1);
		if(!pGBMP)
			throw _T("Memory allocation error");
		pGBMP->BFH.bfType = 'MB'; 
		pGBMP->BFH.bfSize = sizeof(S_GrayBitmap) + Avi.Width() * Avi.Height() - 1;
		pGBMP->BFH.bfOffBits = sizeof(S_GrayBitmap) - 1;
		pGBMP->BIH.biSize = sizeof(BITMAPINFOHEADER);
		pGBMP->BIH.biBitCount = 8;
		pGBMP->BIH.biWidth = Avi.Width();
		pGBMP->BIH.biHeight = -Avi.Height();
		pGBMP->BIH.biPlanes = 1;
		pGBMP->BIH.biSizeImage = Avi.Width() * Avi.Height();
		for(i=0; i<256; i++) {
			pGBMP->Palette[i].rgbBlue = (BYTE)i;
			pGBMP->Palette[i].rgbGreen = (BYTE)i;
			pGBMP->Palette[i].rgbRed = (BYTE)i;
		}

			// Get affixment file name.
		GetFileName(szAffixFileName, _T("Affixment Files (*.xml)\0*.xml\0\0"), FALSE);
		if(lstrlen(szAffixFileName)) {
				// Load affixment from the file.
			if(!AW_LoadFromFile(szAffixFileName, &TMKInit.Affix, &CIParams))
				throw _T("Load affixment error");
		}
		else {
				// No affixment file. Run wizard to make affixment.
			Avi.GetFrame(pGBMP->pbData);
			if(!AW_Show(MainDlg.m_hDlg, (BYTE*)pGBMP, pGBMP->BFH.bfSize, &TMKInit.Affix, &CIParams))
				throw _T("No affixment");

				// Save affixment to the file.
			if(GetFileName(szAffixFileName, _T("Affixment Files (*.xml)\0*.xml\0\0"), TRUE)) {
				if(lstrlen(szAffixFileName) < 5 || lstrcmpi(&szAffixFileName[lstrlen(szAffixFileName) - 4], _T(".xml")))
					lstrcat(szAffixFileName, _T(".xml"));
				AW_SaveToFile(szAffixFileName, &TMKInit.Affix, &CIParams);
			}
		}

			// This fields are not included in affixment file.
		TMKInit.nFrameWidth = Avi.Width();
		TMKInit.nFrameHeight = Avi.Height();
		TMKInit.nFrameRate = Avi.Rate();

		if(TMKER_RES_OK != TMKER_Create(&Kernel))
			throw _T("Error in TMKER_Create()");	

		SetCurrentDirectory(szCurDir);
		
		TMKRes = TMKER_Init(Kernel, &TMKInit);

		if(TMKER_RES_OK != TMKRes) {
			if(TMKER_RES_DONGLE == TMKRes) {
				if(IDYES != MessageBox(MainDlg.m_hDlg, 
						_T("Do you want run this application\nin demonstration mode?"), _T(""), MB_YESNO))
					throw _T("Error in TMKER_Init()");
			}
			else
				throw _T("Error in TMKER_Init()");	
		}

		hMF = BuildMetaFile(Kernel, &TMKInit.Affix);
		nDelay = GetDlgItemInt(MainDlg.m_hDlg, ED_DELAY, (BOOL*)&i, FALSE);

		hWnd = (HWND)lpVoid;
		GetClientRect(hWnd, &rcWnd);

			// Frames loop.
		while(MainDlg.m_fRun) {
			Avi.GetFrame(pGBMP->pbData);

				// Process and show frame.
			hDC = GetDC(hWnd);
			hMemDC = CreateCompatibleDC(hDC);
			hBitmap = CreateCompatibleBitmap(hDC, Avi.Width(), Avi.Height());
			SelectObject(hMemDC, hBitmap);
			SetDIBits(hMemDC, hBitmap, 0, Avi.Height(), pGBMP->pbData, (BITMAPINFO*)&pGBMP->BIH, DIB_RGB_COLORS);

			QueryPerformanceCounter(&CPUTicks);
			n64Tmp = LARGE_INTEGER_TO_UINT_64(CPUTicks);

			TMKER_ProcessFrame(Kernel, pGBMP->pbData, &Event);

			QueryPerformanceCounter(&CPUTicks);
			n64Acc += LARGE_INTEGER_TO_UINT_64(CPUTicks) - n64Tmp;
			n64FrmCnt++;
			if(n64FrmCnt == 100) {
				_tprintf(_T("%u uticks per frame\n"), n64Acc / 100);
				n64Acc = 0;
				n64FrmCnt = 0;
			}

			Overlay(hMemDC, hMF, &Event, TMKInit.Affix.nLanes, &OD);

			StretchBlt(hDC, 0, 0, rcWnd.right, rcWnd.bottom, hMemDC, 0, 0, Avi.Width(), Avi.Height(), SRCCOPY);
			DeleteObject(hBitmap);
			DeleteDC(hMemDC);
			ReleaseDC(NULL, hDC);

				// Delay end switch on another thread.
			Sleep(nDelay);
		}
	}
	catch(TCHAR *szMes) {
		MessageBox(MainDlg.m_hDlg, szMes, _T(""), MB_OK);
	}

	TMKER_Destroy(Kernel);
	Avi.Close();
	GlobalFree(pGBMP);
	if(hMF)
		DeleteMetaFile(hMF);

	return 0;
}

BOOL CALLBACK MainDlgProc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM) {
	switch(msg)
	{
	case WM_INITDIALOG:
		return MainDlg.OnInitDialog(hDlg);
	case WM_CLOSE:
		return MainDlg.OnClose();
	case WM_COMMAND:
		switch(LOWORD(wParam)) {
		case BTN_RUN1:
			return MainDlg.OnBtnRun1();
		case BTN_RUN2:
			return MainDlg.OnBtnRun2();
		}
	}
    return FALSE;
}
}

int main() {
	return static_cast<int>(DialogBox(GetModuleHandle(NULL), MAKEINTRESOURCE(MAIN_DIALOG), NULL, reinterpret_cast<DLGPROC>(MainDlgProc)));	
}

BOOL C_MainDlg::OnInitDialog(HWND hDlg) {
	m_hDlg = hDlg;
	m_fRun = TRUE;
	m_hwndView[0] = GetDlgItem(m_hDlg, ST_VIEW1);
	m_hwndView[1] = GetDlgItem(m_hDlg, ST_VIEW2);

	SetDlgItemInt(m_hDlg, ED_DELAY, 10, FALSE);

	SetWindowPos(m_hDlg, NULL, 0, 0, FRAME_WIDTH * 2 + 34, FRAME_HEIGHT + 100, SWP_NOMOVE | SWP_NOZORDER);
	MoveWindow(m_hwndView[0], 10, 10, FRAME_WIDTH, FRAME_HEIGHT, TRUE); 
	MoveWindow(m_hwndView[1], 20 + FRAME_WIDTH, 10, FRAME_WIDTH, FRAME_HEIGHT, TRUE);
	MoveWindow(GetDlgItem(m_hDlg, BTN_RUN1), FRAME_WIDTH / 2 -  15, FRAME_HEIGHT + 30, 50, 20, TRUE);
	MoveWindow(GetDlgItem(m_hDlg, LAB_DELAY), FRAME_WIDTH - 100, FRAME_HEIGHT + 30, 100, 20, TRUE);
	MoveWindow(GetDlgItem(m_hDlg, ED_DELAY), FRAME_WIDTH, FRAME_HEIGHT + 30, 50, 20, TRUE);
	MoveWindow(GetDlgItem(m_hDlg, BTN_RUN2), static_cast<int>(5 + FRAME_WIDTH * 1.5), FRAME_HEIGHT + 30, 50, 20, TRUE);

	return TRUE;
}

BOOL C_MainDlg::OnClose() {
	m_fRun = FALSE;
	Sleep(2000);
	EndDialog(m_hDlg, 0);
	return TRUE;
}

BOOL C_MainDlg::OnBtnRun1() {
	UINT nThreadId;

	EnableWindow(GetDlgItem(m_hDlg, BTN_RUN1), FALSE);
	m_hThread[0] = reinterpret_cast<HANDLE>(_beginthreadex(NULL, 0, ThreadProc, m_hwndView[0], 0, &nThreadId));
	Sleep(100);

	return TRUE;
}

BOOL C_MainDlg::OnBtnRun2() {
	UINT nThreadId;

	EnableWindow(GetDlgItem(m_hDlg, BTN_RUN2), FALSE);
	m_hThread[1] = reinterpret_cast<HANDLE>(_beginthreadex(NULL, 0, ThreadProc, m_hwndView[1], 0, &nThreadId));
	Sleep(100);

	return TRUE;
}

